blob: 83c726e9e51feb3718e360c157910a2a98a85865 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Orion Hodson64fe3be2018-06-15 12:50:22 +010044export JAVAC="javac -g -Xlint:-options -source 1.8 -target 1.8"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Alan Leungcf2de162018-03-30 20:18:20 +000048export USE_D8="true"
Igor Murashkin2a337752017-06-16 14:34:40 +000049export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070050export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070051
Alan Leungd5cbc562018-03-15 14:02:46 -070052# If d8 was not set by the environment variable, assume it is in the path.
53if [ -z "$D8" ]; then
54 export D8="d8"
55fi
56
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070057# If dx was not set by the environment variable, assume it is in the path.
58if [ -z "$DX" ]; then
Orion Hodson64fe3be2018-06-15 12:50:22 +010059 export DX="d8-compat-dx"
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070060fi
61
Orion Hodson64fe3be2018-06-15 12:50:22 +010062export DEXMERGER="$D8"
Alan Leungd5cbc562018-03-15 14:02:46 -070063
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080064# If jasmin was not set by the environment variable, assume it is in the path.
65if [ -z "$JASMIN" ]; then
66 export JASMIN="jasmin"
67fi
68
Andreas Gampe8fda9f22014-10-03 16:15:37 -070069# If smali was not set by the environment variable, assume it is in the path.
70if [ -z "$SMALI" ]; then
71 export SMALI="smali"
72fi
73
Sebastien Hertz19ac0272015-02-24 17:39:50 +010074# ANDROID_BUILD_TOP is not set in a build environment.
75if [ -z "$ANDROID_BUILD_TOP" ]; then
76 export ANDROID_BUILD_TOP=$oldwd
77fi
78
Dan Willemsen12371e92017-03-06 17:55:20 -080079# OUT_DIR defaults to out, and may be relative to $ANDROID_BUILD_TOP.
80# Convert it to an absolute path, since we cd into the tmp_dir to run the tests.
81export OUT_DIR=${OUT_DIR:-out}
82if [[ "$OUT_DIR" != /* ]]; then
83 export OUT_DIR=$ANDROID_BUILD_TOP/$OUT_DIR
84fi
85
Andreas Gampef47fb2f2016-06-24 22:30:29 -070086# ANDROID_HOST_OUT is not set in a build environment.
87if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsen12371e92017-03-06 17:55:20 -080088 export ANDROID_HOST_OUT=${OUT_DIR}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070089fi
90
Alex Light680cbf22018-10-31 11:00:19 -070091host_lib_root=${ANDROID_HOST_OUT}
92
Igor Murashkine5181932017-06-15 16:03:50 -070093# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070094if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070095 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
96fi
97
Igor Murashkin271a0f82017-02-14 21:14:17 +000098# Zipalign is not on the PATH in some configs, auto-detect it.
99if [ -z "$ZIPALIGN" ]; then
100 if which zipalign >/dev/null; then
101 ZIPALIGN="zipalign";
102 else
103 # TODO: Add a dependency for zipalign in Android.run-test.mk
104 # once it doesn't depend on libandroidfw (b/35246701)
105 case "$OSTYPE" in
106 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
107 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
108 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
109 esac
110 fi
111fi
112export ZIPALIGN
113
David Brazdil122c6632018-01-24 17:32:49 +0000114# If hiddenapi was not set by the environment variable, assume it is in
115# ANDROID_HOST_OUT.
David Brazdil11b67b22018-01-18 16:41:40 +0000116if [ -z "$HIDDENAPI" ]; then
David Brazdil122c6632018-01-24 17:32:49 +0000117 export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi"
David Brazdil11b67b22018-01-18 16:41:40 +0000118fi
119
Roland Levillain76cfe612017-10-30 13:14:28 +0000120chroot=
121
jeffhao5d1ac922011-09-29 17:41:15 -0700122info="info.txt"
123build="build"
124run="run"
125expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700126check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700127output="output.txt"
128build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100129cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700130strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700131lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700132testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700133run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000134build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700135
Alex Light91de25f2015-10-28 17:00:06 -0700136quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000137debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700138prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700139target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700140dev_mode="no"
141update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700142debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000143relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800144runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700145usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700146build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700147suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700148trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700149trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700150basic_verify="false"
151gc_verify="false"
152gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700153jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700154jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700155jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700156jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700157strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700158always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700159never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700160have_image="yes"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000161android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700162bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800163suspend_timeout="500000"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000164image_suffix=""
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100165run_optimizing="false"
jeffhao5d1ac922011-09-29 17:41:15 -0700166
Alex Light20802ca2018-12-05 15:36:03 -0800167# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
168# ART output to approximately 128MB. This should be more than sufficient
169# for any test while still catching cases of runaway output.
170# Set a hard limit to encourage ART developers to increase the ulimit here if
171# needed to support a test case rather than resetting the limit in the run
172# script for the particular test in question. Adjust this if needed for
173# particular configurations.
174file_ulimit=128000
175
jeffhao5d1ac922011-09-29 17:41:15 -0700176while true; do
177 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700178 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700179 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100180 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700181 shift
Alex Light91de25f2015-10-28 17:00:06 -0700182 elif [ "x$1" = "x--quiet" ]; then
183 quiet="yes"
184 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700185 elif [ "x$1" = "x--use-java-home" ]; then
186 if [ -n "${JAVA_HOME}" ]; then
187 export JAVA="${JAVA_HOME}/bin/java"
188 export JAVAC="${JAVA_HOME}/bin/javac -g"
189 else
190 echo "Passed --use-java-home without JAVA_HOME variable set!"
191 usage="yes"
192 fi
193 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800194 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700195 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800196 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800197 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700198 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700199 NEED_DEX="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100200 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700201 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800202 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700203 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700204 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700205 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700206 shift
207 elif [ "x$1" = "x--dalvik" ]; then
208 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800209 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700210 shift
Alex Light03a112d2014-08-25 13:25:56 -0700211 elif [ "x$1" = "x--no-image" ]; then
212 have_image="no"
213 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700214 elif [ "x$1" = "x--relocate" ]; then
215 relocate="yes"
216 shift
217 elif [ "x$1" = "x--no-relocate" ]; then
218 relocate="no"
219 shift
220 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100221 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700222 prebuild_mode="yes"
223 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800224 elif [ "x$1" = "x--compact-dex-level" ]; then
225 option="$1"
226 shift
227 run_args="${run_args} $option $1"
228 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700229 elif [ "x$1" = "x--strip-dex" ]; then
230 run_args="${run_args} --strip-dex"
231 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000232 elif [ "x$1" = "x--debuggable" ]; then
233 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000234 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000235 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700236 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100237 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700238 prebuild_mode="no"
239 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700240 elif [ "x$1" = "x--gcverify" ]; then
241 basic_verify="true"
242 gc_verify="true"
243 shift
244 elif [ "x$1" = "x--gcstress" ]; then
245 basic_verify="true"
246 gc_stress="true"
247 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700248 elif [ "x$1" = "x--jvmti-step-stress" ]; then
249 jvmti_step_stress="true"
250 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700251 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
252 jvmti_redefine_stress="true"
253 shift
Alex Light43e935d2017-06-19 15:40:40 -0700254 elif [ "x$1" = "x--jvmti-field-stress" ]; then
255 jvmti_field_stress="true"
256 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700257 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
258 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700259 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800260 elif [ "x$1" = "x--suspend-timeout" ]; then
261 shift
262 suspend_timeout="$1"
263 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700264 elif [ "x$1" = "x--image" ]; then
265 shift
266 image="$1"
267 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700268 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000269 elif [ "x$1" = "x-Xcompiler-option" ]; then
270 shift
271 option="$1"
272 run_args="${run_args} -Xcompiler-option $option"
273 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000274 elif [ "x$1" = "x--build-option" ]; then
275 shift
276 option="$1"
277 build_args="${build_args} $option"
278 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700279 elif [ "x$1" = "x--runtime-option" ]; then
280 shift
281 option="$1"
282 run_args="${run_args} --runtime-option $option"
283 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700284 elif [ "x$1" = "x--gdb-arg" ]; then
285 shift
286 gdb_arg="$1"
287 run_args="${run_args} --gdb-arg $gdb_arg"
288 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700289 elif [ "x$1" = "x--debug" ]; then
290 run_args="${run_args} --debug"
291 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700292 elif [ "x$1" = "x--debug-wrap-agent" ]; then
293 run_args="${run_args} --debug-wrap-agent"
294 shift
Alex Light0e151e72017-10-25 10:50:35 -0700295 elif [ "x$1" = "x--with-agent" ]; then
296 shift
297 option="$1"
298 run_args="${run_args} --with-agent $1"
299 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700300 elif [ "x$1" = "x--debug-agent" ]; then
301 shift
302 option="$1"
303 run_args="${run_args} --debug-agent $1"
304 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700305 elif [ "x$1" = "x--gdb" ]; then
306 run_args="${run_args} --gdb"
307 dev_mode="yes"
308 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700309 elif [ "x$1" = "x--strace" ]; then
310 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700311 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700312 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700313 elif [ "x$1" = "x--zygote" ]; then
314 run_args="${run_args} --zygote"
315 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800316 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000317 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700318 image_suffix="-interpreter"
319 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800320 elif [ "x$1" = "x--jit" ]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100321 run_args="${run_args} --jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000322 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800323 shift
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100324 elif [ "x$1" = "x--baseline" ]; then
325 run_args="${run_args} --baseline"
326 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700327 elif [ "x$1" = "x--optimizing" ]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100328 run_optimizing="true"
jeffhao0dff3f42012-11-20 15:13:43 -0800329 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700330 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700331 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700332 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700333 elif [ "x$1" = "x--verify-soft-fail" ]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100334 run_args="${run_args} --verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700335 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700336 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700337 elif [ "x$1" = "x--no-optimize" ]; then
338 run_args="${run_args} --no-optimize"
339 shift
340 elif [ "x$1" = "x--no-precise" ]; then
341 run_args="${run_args} --no-precise"
342 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700343 elif [ "x$1" = "x--invoke-with" ]; then
344 shift
345 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700346 if [ "x$what" = "x" ]; then
347 echo "$0 missing argument to --invoke-with" 1>&2
348 usage="yes"
349 break
350 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700351 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700352 shift
353 elif [ "x$1" = "x--dev" ]; then
354 run_args="${run_args} --dev"
355 dev_mode="yes"
356 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700357 elif [ "x$1" = "x--build-only" ]; then
358 build_only="yes"
359 shift
360 elif [ "x$1" = "x--output-path" ]; then
361 shift
362 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700363 if [ "x$tmp_dir" = "x" ]; then
364 echo "$0 missing argument to --output-path" 1>&2
365 usage="yes"
366 break
367 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700368 shift
Roland Levillain76cfe612017-10-30 13:14:28 +0000369 elif [ "x$1" = "x--chroot" ]; then
370 shift
371 if [ "x$1" = "x" ]; then
372 echo "$0 missing argument to --chroot" 1>&2
373 usage="yes"
374 break
375 fi
376 chroot="$1"
377 run_args="${run_args} --chroot $1"
378 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000379 elif [ "x$1" = "x--android-root" ]; then
380 shift
381 if [ "x$1" = "x" ]; then
382 echo "$0 missing argument to --android-root" 1>&2
383 usage="yes"
384 break
385 fi
386 android_root="$1"
387 run_args="${run_args} --android-root $1"
388 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700389 elif [ "x$1" = "x--update" ]; then
390 update_mode="yes"
391 shift
392 elif [ "x$1" = "x--help" ]; then
393 usage="yes"
394 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700395 elif [ "x$1" = "x--64" ]; then
396 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700397 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700398 shift
Alex Light680cbf22018-10-31 11:00:19 -0700399 elif [ "x$1" = "x--bionic" ]; then
400 # soong linux_bionic builds are 64bit only.
401 run_args="${run_args} --bionic --host --64"
402 suffix64="64"
403 target_mode="no"
404 DEX_LOCATION=$tmp_dir
405 host_lib_root=$OUT_DIR/soong/host/linux_bionic-x86
406 shift
Alex Light20802ca2018-12-05 15:36:03 -0800407 elif [ "x$1" = "x--runtime-zipapex" ]; then
408 shift
409 # TODO Should we allow the java.library.path to search the zipapex too?
410 # Not needed at the moment and adding it will be complicated so for now
411 # we'll ignore this.
412 run_args="${run_args} --host --runtime-zipapex $1"
413 target_mode="no"
414 DEX_LOCATION=$tmp_dir
415 # apex_payload.zip is quite large we need a high enough ulimit to
416 # extract it. 512mb should be good enough.
417 file_ulimit=512000
418 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200419 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700420 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200421 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700422 elif [ "x$1" = "x--stream" ]; then
423 trace_stream="true"
424 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700425 elif [ "x$1" = "x--always-clean" ]; then
426 always_clean="yes"
427 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700428 elif [ "x$1" = "x--never-clean" ]; then
429 never_clean="yes"
430 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800431 elif [ "x$1" = "x--dex2oat-swap" ]; then
432 run_args="${run_args} --dex2oat-swap"
433 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700434 elif [ "x$1" = "x--instruction-set-features" ]; then
435 shift
436 run_args="${run_args} --instruction-set-features $1"
437 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700438 elif [ "x$1" = "x--bisection-search" ]; then
439 bisection_search="yes"
440 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000441 elif [ "x$1" = "x--vdex" ]; then
442 run_args="${run_args} --vdex"
443 shift
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000444 elif [ "x$1" = "x--dm" ]; then
445 run_args="${run_args} --dm"
446 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000447 elif [ "x$1" = "x--vdex-filter" ]; then
448 shift
449 filter=$1
450 run_args="${run_args} --vdex-filter $filter"
451 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700452 elif [ "x$1" = "x--random-profile" ]; then
453 run_args="${run_args} --random-profile"
454 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700455 elif [ "x$1" = "x--dex2oat-jobs" ]; then
456 shift
457 run_args="${run_args} -Xcompiler-option -j$1"
458 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700459 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700460 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700461 usage="yes"
462 break
463 else
464 break
465 fi
466done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700467
Orion Hodson6aa4e0d2018-05-25 09:39:16 +0100468if [ "$usage" = "no" -a "x$1" = "x" ]; then
469 echo "missing test to run" 1>&2
470 usage="yes"
471fi
472
Roland Levillain76cfe612017-10-30 13:14:28 +0000473# The DEX_LOCATION with the chroot prefix, if any.
474chroot_dex_location="$chroot$DEX_LOCATION"
475
Alex Light91de25f2015-10-28 17:00:06 -0700476# Allocate file descriptor real_stderr and redirect it to the shell's error
477# output (fd 2).
478if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
479 exec {real_stderr}>&2
480else
481 # In bash before version 4.1 we need to do a manual search for free file
482 # descriptors.
483 FD=3
484 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
485 real_stderr=$FD
486 eval "exec ${real_stderr}>&2"
487fi
488if [ "$quiet" = "yes" ]; then
489 # Force the default standard output and error to go to /dev/null so we will
490 # not print them.
491 exec 1>/dev/null
492 exec 2>/dev/null
493fi
494
495function err_echo() {
496 echo "$@" 1>&${real_stderr}
497}
498
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700499# tmp_dir may be relative, resolve.
500#
501# Cannot use realpath, as it does not exist on Mac.
Roland Levillain76cfe612017-10-30 13:14:28 +0000502# Cannot use a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700503# Cannot use readlink -m, as it does not exist on Mac.
504# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700505noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700506tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700507mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700508
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800509# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000510if [ ! "$runtime" = "jvm" ]; then
511 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
512fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800513
Alex Lighte7873ec2014-08-12 09:53:50 -0700514if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800515 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
516 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700517fi
518if [ "$gc_verify" = "true" ]; then
519 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
520fi
521if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700522 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700523fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700524if [ "$jvmti_redefine_stress" = "true" ]; then
525 run_args="${run_args} --no-app-image --jvmti-redefine-stress"
526fi
Alex Lightc38c3692017-06-27 15:45:14 -0700527if [ "$jvmti_step_stress" = "true" ]; then
528 run_args="${run_args} --no-app-image --jvmti-step-stress"
529fi
Alex Light43e935d2017-06-19 15:40:40 -0700530if [ "$jvmti_field_stress" = "true" ]; then
531 run_args="${run_args} --no-app-image --jvmti-field-stress"
532fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700533if [ "$jvmti_trace_stress" = "true" ]; then
534 run_args="${run_args} --no-app-image --jvmti-trace-stress"
Alex Light8f2c6d42017-04-10 16:27:35 -0700535fi
Jeff Hao85139a32014-07-23 11:52:52 -0700536if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700537 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
538 if [ "$trace_stream" = "true" ]; then
539 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
540 # the ability to analyze the file and just write to /dev/null.
541 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
542 # Enable streaming mode.
543 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
544 else
545 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
546 fi
547elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700548 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700549 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700550fi
551
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700552# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000553# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100554function guess_target_arch_name() {
Andreas Gamped0566d42018-06-06 09:54:34 -0700555 # Check whether this is a device with native bridge. Currently this is hardcoded
556 # to x86 + arm.
557 x86_arm=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | sort | grep -E '^(arm|x86)$'`
558 # Collapse line-breaks into spaces
559 x86_arm=$(echo $x86_arm)
560 if [ "x$x86_arm" = "xarm x86" ] ; then
561 err_echo "Native-bridge configuration detected."
562 # We only support the main arch for tests.
563 if [ "x${suffix64}" = "x64" ]; then
564 target_arch_name=""
565 else
566 target_arch_name=x86
567 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700568 else
Andreas Gamped0566d42018-06-06 09:54:34 -0700569 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
570 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
571 if [ "x${suffix64}" = "x64" ]; then
572 target_arch_name=${grep64bit}
573 else
574 target_arch_name=${grep32bit}
575 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700576 fi
577}
578
David Brazdil853a4c32015-09-28 16:15:50 +0100579function guess_host_arch_name() {
580 if [ "x${suffix64}" = "x64" ]; then
581 host_arch_name="x86_64"
582 else
583 host_arch_name="x86"
584 fi
585}
586
Alex Lighta59dd802014-07-02 16:28:08 -0700587if [ "$target_mode" = "no" ]; then
588 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700589 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700590 err_echo "--prebuild with --jvm is unsupported"
Roland Levillain76cfe612017-10-30 13:14:28 +0000591 exit 1
592 fi
593 else
594 # ART/Dalvik host mode.
595 if [ -n "$chroot" ]; then
596 err_echo "--chroot with --host is unsupported"
597 exit 1
Alex Lighta59dd802014-07-02 16:28:08 -0700598 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700599 fi
600fi
601
Jeff Hao201803f2013-11-20 18:11:39 -0800602if [ ! "$runtime" = "jvm" ]; then
603 run_args="${run_args} --lib $lib"
604fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700605
Jeff Hao201803f2013-11-20 18:11:39 -0800606if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700607 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000608 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800609 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700610 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700611 else
612 true # defaults to using target BOOTCLASSPATH
613 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800614elif [ "$runtime" = "art" ]; then
615 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100616 guess_host_arch_name
Vladimir Marko4519b9d2018-10-10 15:21:21 +0100617 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}.art"
Alex Light680cbf22018-10-31 11:00:19 -0700618 run_args="${run_args} --runtime-option -Djava.library.path=${host_lib_root}/lib${suffix64}:${host_lib_root}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800619 else
David Brazdil853a4c32015-09-28 16:15:50 +0100620 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800621 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Vladimir Marko4519b9d2018-10-10 15:21:21 +0100622 run_args="${run_args} --boot /data/art-test/core${image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800623 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700624 if [ "$relocate" = "yes" ]; then
625 run_args="${run_args} --relocate"
626 else
627 run_args="${run_args} --no-relocate"
628 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700629elif [ "$runtime" = "jvm" ]; then
630 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800631 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700632fi
633
Alex Light03a112d2014-08-25 13:25:56 -0700634if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700635 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700636 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700637 exit 1
638 fi
Alex Light03a112d2014-08-25 13:25:56 -0700639 run_args="${run_args} --no-image"
640fi
641
jeffhao5d1ac922011-09-29 17:41:15 -0700642if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700643 err_echo "--dev and --update are mutually exclusive"
644 usage="yes"
645fi
646
647if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
648 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700649 usage="yes"
650fi
651
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700652if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
653 err_echo "--bisection-search and --prebuild are mutually exclusive"
654 usage="yes"
655fi
656
Roland Levillain76cfe612017-10-30 13:14:28 +0000657# TODO: Chroot-based bisection search is not supported yet (see below); implement it.
658if [ "$bisection_search" = "yes" -a -n "$chroot" ]; then
659 err_echo "--chroot with --bisection-search is unsupported"
660 exit 1
661fi
662
jeffhao5d1ac922011-09-29 17:41:15 -0700663if [ "$usage" = "no" ]; then
664 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
665 test_dir=`basename "$oldwd"`
666 else
667 test_dir="$1"
668 fi
669
670 if [ '!' -d "$test_dir" ]; then
671 td2=`echo ${test_dir}-*`
672 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700673 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700674 usage="yes"
675 fi
676 test_dir="$td2"
677 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700678 # Shift to get rid of the test name argument. The rest of the arguments
679 # will get passed to the test run.
680 shift
681fi
682
683if [ "$usage" = "yes" ]; then
684 prog=`basename $prog`
685 (
686 echo "usage:"
687 echo " $prog --help Print this message."
688 echo " $prog [options] [test-name] Run test normally."
689 echo " $prog --dev [options] [test-name] Development mode" \
690 "(dumps to stdout)."
691 echo " $prog --update [options] [test-name] Update mode" \
692 "(replaces expected.txt)."
693 echo ' Omitting the test name or specifying "-" will use the' \
694 "current directory."
695 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000696 echo " -O Run non-debug rather than debug build (off by default)."
697 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000698 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000699 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800700 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700701 echo " --debug Wait for the default debugger to attach."
702 echo " --debug-agent <agent-path>"
703 echo " Wait for the given debugger agent to attach. Currently"
704 echo " only supported on host."
705 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
706 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700707 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000708 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000709 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700710 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000711 echo " --build-only Build test files only (off by default)."
712 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800713 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000714 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000715 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700716 echo " --verify-soft-fail Force soft fail verification (off by default)."
717 echo " Verification is enabled if neither --no-verify"
718 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000719 echo " --no-optimize Turn off optimization (on by default)."
720 echo " --no-precise Turn off precise GC (on by default)."
721 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700722 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000723 echo " other runtime options are ignored."
724 echo " --no-dex2oat Run as though dex2oat was failing."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000725 echo " --prebuild Run dex2oat on the files before starting test. (default)"
726 echo " --no-prebuild Do not run dex2oat on the files before starting"
727 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700728 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000729 echo " --relocate Force the use of relocating in the test, making"
730 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000731 echo " address before running."
732 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700733 echo " --image Run the test using a precompiled boot image. (default)"
734 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000735 echo " --host Use the host-mode virtual machine."
736 echo " --invoke-with Pass --invoke-with option to runtime."
737 echo " --dalvik Use Dalvik (off by default)."
738 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700739 echo " --use-java-home Use the JAVA_HOME environment variable"
740 echo " to find the java compiler and runtime"
741 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000742 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700743 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000744 echo " --64 Run the test in 64-bit mode"
Alex Light680cbf22018-10-31 11:00:19 -0700745 echo " --bionic Use the (host, 64-bit only) linux_bionic libc runtime"
Alex Light20802ca2018-12-05 15:36:03 -0800746 echo " --runtime-zipapex [file]"
747 echo " Use the given zipapex file to provide runtime binaries"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000748 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700749 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700750 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000751 echo " --gcstress Run with gc stress testing"
752 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700753 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700754 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700755 echo " --jvmti-redefine-stress"
756 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000757 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700758 echo " --never-clean Keep the test files even if the test succeeds."
Roland Levillain76cfe612017-10-30 13:14:28 +0000759 echo " --chroot [newroot] Run with root directory set to newroot."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000760 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000761 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700762 echo " --instruction-set-features [string]"
763 echo " Set instruction-set-features for compilation."
Alex Light91de25f2015-10-28 17:00:06 -0700764 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700765 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000766 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800767 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700768 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700769 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700770 exit 1
771fi
772
773cd "$test_dir"
774test_dir=`pwd`
775
776td_info="${test_dir}/${info}"
777td_expected="${test_dir}/${expected}"
778
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700779if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700780 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700781 exit 1
782fi
783
784if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700785 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700786 exit 1
787fi
788
789# copy the test to a temp dir and run it
790
Elliott Hughes510c8782011-10-06 10:57:34 -0700791echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700792
793rm -rf "$tmp_dir"
Alex Light0aa7a5a2018-10-10 15:58:14 +0000794cp -LRp "$test_dir" "$tmp_dir"
jeffhao5d1ac922011-09-29 17:41:15 -0700795cd "$tmp_dir"
796
797if [ '!' -r "$build" ]; then
798 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800799else
800 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700801fi
802
803if [ '!' -r "$run" ]; then
804 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800805else
806 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700807fi
808
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700809if [ '!' -r "$check_cmd" ]; then
810 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800811else
812 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700813fi
814
jeffhao5d1ac922011-09-29 17:41:15 -0700815chmod 755 "$build"
816chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700817chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700818
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700819export TEST_NAME=`basename ${test_dir}`
820
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000821# Tests named '<number>-checker-*' will also have their CFGs verified with
822# Checker when compiled with Optimizing on host.
823if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100824 if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$run_optimizing" = "true" ]; then
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000825 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
826 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
827 run_checker="yes"
828
829 if [ "$target_mode" = "no" ]; then
830 cfg_output_dir="$tmp_dir"
831 checker_args="--arch=${host_arch_name^^}"
832 else
833 cfg_output_dir="$DEX_LOCATION"
834 checker_args="--arch=${target_arch_name^^}"
835 fi
836
837 if [ "$debuggable" = "yes" ]; then
838 checker_args="$checker_args --debuggable"
839 fi
840
841 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
842 -Xcompiler-option -j1"
843 fi
844 fi
845fi
846
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100847run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700848
Alex Light20802ca2018-12-05 15:36:03 -0800849if ! ulimit -f ${file_ulimit}; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000850 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700851fi
852
Igor Murashkin2de6e082018-02-28 15:25:23 -0800853# Tell the build script which mode (target, host, jvm) we are building for
854# to determine the bootclasspath at build time.
Igor Murashkin2a337752017-06-16 14:34:40 +0000855if [[ "$target_mode" == "yes" ]]; then
856 build_args="$build_args --target"
857else
Igor Murashkin2de6e082018-02-28 15:25:23 -0800858 if [[ $runtime == "jvm" ]]; then
859 build_args="$build_args --jvm"
860 else
861 build_args="$build_args --host"
862 fi
Igor Murashkin2a337752017-06-16 14:34:40 +0000863fi
864
865if [[ "$dev_mode" == "yes" ]]; then
866 build_args="$build_args --dev"
867fi
868
jeffhao5d1ac922011-09-29 17:41:15 -0700869good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000870good_build="yes"
871good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700872export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700873if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000874 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700875 build_exit="$?"
876 echo "build exit status: $build_exit" 1>&2
877 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800878 echo "${test_dir}: running..." 1>&2
879 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700880 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000881
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800882 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000883 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100884 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000885 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100886 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100887 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000888 checker_exit="$?"
889 if [ "$checker_exit" = "0" ]; then
890 good="yes"
891 fi
Alex Light91de25f2015-10-28 17:00:06 -0700892 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000893 else
894 good="yes"
895 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800896 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000897 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700898 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700899elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000900 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700901 build_exit="$?"
902 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800903 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700904 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000905 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100906 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000907 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100908 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100909 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000910 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700911 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
912 good="yes"
913 else
Alex Light91de25f2015-10-28 17:00:06 -0700914 cat "$build_output" 1>&${real_stderr} 1>&2
915 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700916 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700917elif [ "$build_only" = "yes" ]; then
918 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000919 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700920 build_exit="$?"
921 if [ "$build_exit" '!=' '0' ]; then
922 cp "$build_output" "$output"
923 echo "build exit status: $build_exit" >>"$output"
924 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
925 if [ "$?" '!=' "0" ]; then
926 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700927 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700928 fi
929 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700930 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700931 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700932 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700933else
David Brazdil4846d132015-01-15 19:07:08 +0000934 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700935 build_exit="$?"
936 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800937 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700938 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000939 run_exit="$?"
940 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700941 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000942 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000943 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100944 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000945 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100946 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100947 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000948 checker_exit="$?"
949 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700950 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000951 good_run="no"
952 else
953 good_run="yes"
954 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000955 else
956 good_run="yes"
957 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700958 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000959 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700960 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700961 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
962 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700963 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700964 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700965 max_name_length=$(getconf NAME_MAX ${tmp_dir})
966 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
967 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700968 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700969 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700970 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700971 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000972 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
973 # output == expected
974 good="yes"
975 echo "${test_dir}: succeeded!" 1>&2
976 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700977 fi
978fi
979
jeffhao5d1ac922011-09-29 17:41:15 -0700980(
Alex Lightbfac14a2014-07-30 09:41:21 -0700981 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700982 echo "${test_dir}: FAILED!"
983 echo ' '
984 echo '#################### info'
985 cat "${td_info}" | sed 's/^/# /g'
986 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700987 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700988 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700989 if [ "$strace" = "yes" ]; then
990 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700991 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700992 echo '####################'
993 fi
Andreas Gampee79ca192017-07-31 10:30:16 -0700994 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
995 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
996 # tools used by the given ABI work for both x86 and x86-64.
997 echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
998 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700999 echo ' '
1000 fi
Alex Lightbfac14a2014-07-30 09:41:21 -07001001
Alex Light91de25f2015-10-28 17:00:06 -07001002) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -07001003
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001004# Attempt bisection only if the test failed.
Roland Levillain76cfe612017-10-30 13:14:28 +00001005# TODO: Implement support for chroot-based bisection search.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001006if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
1007 # Bisecting works by skipping different optimization passes which breaks checker assertions.
1008 if [ "$run_checker" == "yes" ]; then
1009 echo "${test_dir}: not bisecting, checker test." 1>&2
1010 else
1011 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001012 echo "${test_dir}: bisecting..." 1>&2
1013 cwd=`pwd`
1014 maybe_device_mode=""
1015 raw_cmd=""
1016 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001017 # Produce cmdline.sh in $chroot_dex_location. "$@" is passed as a runtime option
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001018 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
1019 # to exec in order to preserve pid when calling dalvikvm. This is required
1020 # for bisection search to correctly retrieve logs from device.
1021 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
Roland Levillain76cfe612017-10-30 13:14:28 +00001022 adb shell chmod u+x "$chroot_dex_location/cmdline.sh"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001023 maybe_device_mode="--device"
1024 raw_cmd="$DEX_LOCATION/cmdline.sh"
1025 else
1026 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
1027 fi
Roland Levillain76cfe612017-10-30 13:14:28 +00001028 # TODO: Pass a `--chroot` option to the bisection_search.py script and use it there.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001029 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
1030 $maybe_device_mode \
1031 --raw-cmd="$raw_cmd" \
1032 --check-script="$cwd/check" \
1033 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001034 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001035 --timeout=300
1036 fi
1037fi
1038
Alex Lightbfac14a2014-07-30 09:41:21 -07001039# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001040if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001041 cd "$oldwd"
1042 rm -rf "$tmp_dir"
1043 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001044 adb shell rm -rf $chroot_dex_location
Alex Lightbfac14a2014-07-30 09:41:21 -07001045 fi
1046 if [ "$good" = "yes" ]; then
1047 exit 0
1048 fi
1049fi
1050
1051
1052(
1053 if [ "$always_clean" = "yes" ]; then
1054 echo "${TEST_NAME} files deleted from host "
1055 if [ "$target_mode" == "yes" ]; then
1056 echo "and from target"
1057 fi
1058 else
1059 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1060 if [ "$target_mode" == "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001061 echo "and in ${chroot_dex_location} on target"
Alex Lightbfac14a2014-07-30 09:41:21 -07001062 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001063 fi
1064
Alex Light91de25f2015-10-28 17:00:06 -07001065) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001066
Alex Light6a870fa2016-05-31 16:36:19 -07001067if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1068 exit 0
1069else
1070 exit 1
1071fi